<?php
/*
get the image of the relevant size pass in argument if no size pass in argument it will return the thumbnail
*/
function tmpl_get_image_withinfo( $iPostID, $img_size = 'thumb', $no_images = '' ) {

	$arrImages = get_children( 'order=ASC&orderby=menu_order ID&post_type=attachment&post_mime_type=image&post_parent=' . @$iPostID );
	$counter = 0;
	$return_arr = array();

	if ( has_post_thumbnail( $iPostID ) ) {

		$img_arr = wp_get_attachment_image_src( get_post_thumbnail_id( $iPostID ), $img_size );
		$imgarr['id'] = get_post_thumbnail_id( $iPostID );
		;
		$imgarr['file'] = $img_arr[0];
		$return_arr[] = $imgarr;

	} else {
		if ( $arrImages ) {

			foreach ( $arrImages as $key => $val ) {
				$id = $val->ID;
				if ( $val->post_title != '' ) {
					if ( $img_size == 'thumb' ) {
						$img_arr = wp_get_attachment_image_src( $id, 'thumbnail' ); // Get the thumbnail url for the attachment
						$imgarr['id'] = $id;
						$imgarr['file'] = $img_arr[0];
						$return_arr[] = $imgarr;
					} else {
						$img_arr = wp_get_attachment_image_src( $id, $img_size );
						$imgarr['id'] = $id;
						$imgarr['file'] = $img_arr[0];
						$return_arr[] = $imgarr;
					}
				}
				$counter++;
				if ( $no_images != '' && $counter == $no_images ) {
					break;
				}
			}
		} else {
				$imgarr['id'] = 0;
				$imgarr['file'] = '//via.placeholder.com/185x130/333333/999999&text=Thumbnail';
				$return_arr[] = $imgarr;
		}
	}// End if().
	return $return_arr;
}


/*
Return post pagination on detail page(previous & next post)
*/
function tmpl_get_post_pagination( $post ) {

	if ( $post->post_type == CUSTOM_POST_TYPE ) {
		$prev_post = tmpl_get_adjacent_post( $in_same_term = false, $excluded_terms = '', $previous = true, $taxonomy = CUSTOM_CATEGORY_SLUG );
		$next_post = tmpl_get_adjacent_post( $in_same_term = false, $excluded_terms = '', $previous = false, $taxonomy = CUSTOM_CATEGORY_SLUG );
	} else {
		$prev_post = tmpl_get_adjacent_post( $in_same_term = false, $excluded_terms = '', $previous = true, $taxonomy = 'category' );
		$next_post = tmpl_get_adjacent_post( $in_same_term = false, $excluded_terms = '', $previous = false, $taxonomy = 'category' );
	}

			/* fetch previous post details */
	if ( $prev_post ) :
		$prev_post_url = esc_url( get_permalink( $prev_post->ID ) );
		$prev_post_title = $prev_post->post_title;

		$post_images = tmpl_get_image_withinfo( $prev_post->ID,'listing-widget-thumb' );   // get previous post image
		$attachment_id = $post_images[0]['id'];
		$alt = get_post_meta( $attachment_id, '_wp_attachment_image_alt', true );
		$attach_data = get_post( $attachment_id );
		$title = $attach_data->post_title;

		if ( $title == '' ) { $title = $prev_post->post_title; }

		if ( $alt == '' ) { $alt = $prev_post->post_title; }
		$image = wp_get_attachment_image_src( get_post_thumbnail_id( $prev_post->ID ), 'listing-widget-thumb' ); // get the previous post image src

		if ( isset( $image[0] ) && $image[0] != '' ) {
			 $prev_post_images = $image[0];
		} elseif ( $post_images[0]['file'] ) {
			$prev_post_images = $post_images[0]['file'];

		} else {
			$prev_post_images = get_template_directory_uri() . '/images/img_not_available.png';
		}
?>
	  
<!-- Previous post html -->
<div class="small-6 columns prev-icon">
							
		<div class="small-3 hide-for-xsmall-only show-for-medium-up columns">
		<a href="<?php echo esc_url( get_permalink( $prev_post->ID ) ); ?>"><i class="fa fa-chevron-left step"></i><img style="max-height:50px;max-width:75px; width:100%; height:auto;" src="<?php echo $prev_post_images; ?>" alt="<?php echo $prev_post_title; ?>" /></a>
	</div>
	<div class="medium-9 small-12 columns">
		<span><?php _e( 'Previous Post','templatic' );?></span>
		<h6><a href="<?php echo esc_url( get_permalink( $prev_post->ID ) ); ?>"><?php echo $prev_post->post_title; ?></a></h6>
	</div>

		</div>
		<?php endif;
		/* fetch Next post details */
	if ( $next_post ) : $next_post_url = esc_url( get_permalink( $next_post->ID ) );

			$post_nimages = tmpl_get_image_withinfo( $next_post->ID,'listing-widget-thumb' );
			$attachment_id = $post_nimages[0]['id'];
			$altn = get_post_meta( $attachment_id, '_wp_attachment_image_alt', true );
			$attach_data = get_post( $attachment_id );
			$next_post_title = $attach_data->post_title;

		if ( $next_post_title == '' ) { $next_post_title = $next_post->post_title; }
		if ( $altn == '' ) { $altn = $next_post->post_title; }

			$image = wp_get_attachment_image_src( get_post_thumbnail_id( $next_post->ID ), 'listing-widget-thumb' ); // get next post image src

		if ( isset( $image[0] ) && $image[0] != '' ) {
			 $next_post_images = $image[0];
		} elseif ( $post_nimages[0]['file'] ) {
			$next_post_images = $post_nimages[0]['file'];
		} else {
			$next_post_images = get_stylesheet_directory_uri() . '/images/img_not_available.png';
		} ?>
			  <!-- Next post html -->
			  <div class="small-6 columns next-icon">
					
					<div class="medium-9 small-12 columns text-right">
					<span><?php _e( 'Next Post','templatic' );?></span>
					<h6><a href="<?php echo esc_url( get_permalink( $next_post->ID ) ); ?>"><?php echo $next_post->post_title; ?></a></h6>
					</div>
					<div class="small-3 hide-for-xsmall-only show-for-medium-up columns">
					<a href="<?php echo esc_url( get_permalink( $next_post->ID ) ); ?>"><img style="max-height:50px;max-width:75px; width:100%; height:auto;" src="<?php echo $next_post_images; ?>" alt="<?php echo $next_post_title; ?>" /><i class="fa fa-chevron-right step"></i></a>
					</div>

				</div>
		<?php endif; ?>
		<?php
}

// Remove issues with pre fetching adding extra views
remove_action( 'wp_head', 'adjacent_posts_rel_link_wp_head', 10, 0 );

/**
 Register the theme widget areas
 */
function tmpl_get_sidebars() {
	/* Set up an array of sidebars. */
	global $theme_sidebars,$plugin_sidebars;
	/* $theme_sidebars - Use when create the child category , it will use full to give the sequence to widget area*/
	if ( empty( $theme_sidebars ) ) {
		$theme_sidebars = array( '' );
	}
	if ( empty( $plugin_sidebars ) ) {
		$plugin_sidebars = array( '' );
	}

	$sidebars = array(
		'header_right' => array(
			'name' => __( 'Header Right', 'templatic' ),
			'description' => apply_filters( 'front_banner_desc',__( 'The area is located on the right side of your Logo (example serch widget).', 'templatic' ) ),
		),
		'navigation_right' => array(
			'name' => __( 'Navigation Right', 'templatic' ),
			'description' => apply_filters( 'front_banner_desc',__( 'The area is located on the right side of your menu (example serch widget).', 'templatic' ) ),
		),

		'offcanvas' => array(
			'name' => __( 'Offcanvas', 'templatic' ),
			'description' => __( 'The offcanvas sidebar will appear on the left side when you click on the menu icon in devices with smaller widths.', 'templatic' ),
	),

		'sidebar1' => array(
			'name' => __( 'Primary Sidebar', 'templatic' ),
			'description' => __( 'This sidebar will appear on all your WordPress pages.', 'templatic' ),
		),
		'front_sidebar' => array(
			'name' => __( 'Home Page  - Sidebar', 'templatic' ),
			'description' => apply_filters( 'tmpl_home_page_widget_area_description',__( 'This area appears alongside the homepage sidebar.','templatic' ) ),
		),

		'post_category_sidebar' => array(
			'name' => __( 'Blog Listing Page - Sidebar', 'templatic' ),
			'description' => __( 'This sidebar will be shown on your blog and post category pages.', 'templatic' ),
		),

		'post_detail_sidebar' => array(
			'name' => __( 'Blog Detail Page - Sidebar', 'templatic' ),
			'description' => __( 'This sidebar will show on detail (single) Post pages.', 'templatic' ),
		),

		'footer_content' => array(
			'name' => __( 'Footer', 'templatic' ),
			'description' => __( 'Displays widgets inside the Footer in four columns.', 'templatic' ),
		),

	);

	$sidebars = array_merge( $sidebars,$theme_sidebars,$plugin_sidebars );
	/* Return the sidebars. */

	return $sidebars;
}

/* Register widget areas. */
add_action( 'widgets_init', 'tmpl_register_sidebars' );
/*
 Name :tmpl_register_sidebars
 Description : Registers the theme supported sidebars
*/

function tmpl_register_sidebars() {
	/* Get the theme-supported sidebars. */
	$supported_sidebars = get_theme_support( 'tmpl-core-sidebars' );
	/* If the theme doesn't add support for any sidebars, return. */

	/* Get the available core framework sidebars. */
	$core_sidebars = tmpl_get_sidebars();
	/* Loop through the supported sidebars. */

	foreach ( $core_sidebars as $key => $value ) {

		/* Make sure the given sidebar is one of the core sidebars. */
		if ( isset( $core_sidebars[ $key ] ) ) {
			/* Set up some default sidebar arguments. */
			$defaults = array(
				'before_widget' => '<div id="%1$s" class="widget %2$s"><div class="widget-wrap widget-inside">',
				'after_widget' => '</div></div>',
				'before_title' => '<h3 class="widget-title h2">',
				'after_title' => '</h3>',
			);
			/* Parse the sidebar arguments and defaults. */
			$args = wp_parse_args( $core_sidebars[ $key ], $defaults );
			/* If no 'id' was given, use the $sidebar variable and sanitize it. */
			$args['id'] = ( isset( $args['id'] ) ? sanitize_key( $args['id'] ) : sanitize_key( $key ) );
			/* Register the sidebar. */

			if ( @$args['name'] != '' ) {
				register_sidebar( $args );
			}
		}
	}

}

/* return post's author link */
function tmpl_get_the_author_posts_link( $post ) {
	$userdata = get_userdata( $post->post_author );
	return '<a href="' . get_author_posts_url( $post->post_author ) . '">' . $userdata->display_name . '</a>';
}

/*
Display previous/next post pagination for detail page with different taxonomy.
*/
function tmpl_get_adjacent_post( $in_same_term = false, $excluded_terms = '', $previous = true, $taxonomy = 'category' ) {
	global $wpdb;

	if ( ( ! $post = get_post() ) || ! taxonomy_exists( $taxonomy ) ) {
		return null;
	}

	$current_post_date = $post->post_date;

	$join = '';
	$posts_in_ex_terms_sql = '';
	/* Check if it should come from same term or from different */
	if ( $in_same_term || ! empty( $excluded_terms ) ) {
		$join = " INNER JOIN $wpdb->term_relationships AS tr ON p.ID = tr.object_id INNER JOIN $wpdb->term_taxonomy tt ON tr.term_taxonomy_id = tt.term_taxonomy_id";

		if ( $in_same_term ) {
			if ( ! is_object_in_taxonomy( $post->post_type, $taxonomy ) ) {
				return '';
			}
			$term_array = wp_get_object_terms( $post->ID, $taxonomy, array(
				'fields' => 'ids',
			) );
			if ( ! $term_array || is_wp_error( $term_array ) ) {
				return '';
			}
			$join .= $wpdb->prepare( ' AND tt.taxonomy = %s AND tt.term_id IN (' . implode( ',', array_map( 'intval', $term_array ) ) . ')', $taxonomy );
		}

		$posts_in_ex_terms_sql = $wpdb->prepare( 'AND tt.taxonomy = %s', $taxonomy );
		if ( ! empty( $excluded_terms ) ) {
			if ( ! is_array( $excluded_terms ) ) {
				// back-compat, $excluded_terms used to be $excluded_terms with IDs separated by " and "
				if ( false !== strpos( $excluded_terms, ' and ' ) ) {
					_deprecated_argument( __FUNCTION__, '3.3', sprintf( __( 'Use commas instead of %s to separate excluded terms.','templatic' ), "'and'" ) );
					$excluded_terms = explode( ' and ', $excluded_terms );
				} else {
					$excluded_terms = explode( ',', $excluded_terms );
				}
			}

			$excluded_terms = array_map( 'intval', $excluded_terms );

			if ( ! empty( $term_array ) ) {
				$excluded_terms = array_diff( $excluded_terms, $term_array );
				$posts_in_ex_terms_sql = '';
			}

			if ( ! empty( $excluded_terms ) ) {
				$posts_in_ex_terms_sql = $wpdb->prepare( ' AND tt.taxonomy = %s AND tt.term_id NOT IN (' . implode( $excluded_terms, ',' ) . ')', $taxonomy );
			}
		}
	}// End if().

	$adjacent = $previous ? 'previous' : 'next';
	$op = $previous ? '<' : '>';
	$order = $previous ? 'DESC' : 'ASC';

	$join  = apply_filters( "get_{$adjacent}_post_join", $join, $in_same_term, $excluded_terms );
	$where = apply_filters( "get_{$adjacent}_post_where", $wpdb->prepare( "WHERE p.post_date $op %s AND p.post_type = %s AND p.post_status = 'publish' $posts_in_ex_terms_sql", $current_post_date, $post->post_type ), $in_same_term, $excluded_terms );
	$sort  = apply_filters( "get_{$adjacent}_post_sort", "ORDER BY p.post_date $order LIMIT 1" );

	$query = "SELECT p.ID FROM $wpdb->posts AS p $join $where $sort";
	$query_key = 'adjacent_post_' . md5( $query );
	$result = wp_cache_get( $query_key, 'counts' );
	if ( false !== $result ) {
		if ( $result ) {
			$result = get_post( $result );
		}
		return $result;
	}

	$result = $wpdb->get_var( $query );
	if ( null === $result ) {
		$result = '';
	}

	wp_cache_set( $query_key, $result, 'counts' );

	if ( $result ) {
		$result = get_post( $result );
	}

	return $result;
}

/* get customizer settings */
function tmpl_get_theme_settings( $option = '' ) {
	$theme_settings = get_option( 'templatic_theme_settings' );
	if ( isset( $theme_settings[ $option ] ) && $theme_settings[ $option ] != '' ) {
		return $theme_settings[ $option ];
	} else { 		return false;
	}
}

/* action to set the templatic advertisement widget */
add_action( 'wp_dashboard_setup', 'TemplaticDashboardWidgetSetup' );
function TemplaticDashboardWidgetSetup() {
	add_meta_box( 'templatic_dashboard_news_widget', __( 'News From Templatic','templatic' ), 'TmplDashboardWidgetFunction', 'dashboard', 'normal', 'high' );
}

/* TemplaticDashboardWidgetFunction - Admin dashboard widget to show templatic news */
function TmplDashboardWidgetFunction() {
	?>
<div class="table table_tnews">
  <div class="trss-widget">
	<?php
	$items = get_transient( 'templatic_dashboard_news' );

	if ( empty( $items ) ) {
		include_once( ABSPATH . WPINC . '/class-simplepie.php' );
		$trss = new SimplePie();
		$trss->set_timeout( 5 );
		$trss->set_feed_url( '//feeds.feedburner.com/Templatic' );
		$trss->strip_htmltags( array_merge( $trss->strip_htmltags, array( 'h1', 'a' ) ) );
		$trss->enable_cache( false );
		$trss->init();

		if ( is_wp_error( $trss ) ) {
			if ( is_admin() || current_user_can( 'manage_options' ) ) {
				echo '<div class="rss-widget"><p>';
				printf( __( '<strong>RSS Error</strong>: %s','templatic' ), $trss->get_error_message() );
				echo '</p></div>';
			}
		}

		$items = $trss->get_items( 0, 6 );
		$cached = array();

		foreach ( $items as $item ) {
			 preg_match( '/(.{128}.*?)\b/', $item->get_content(), $matches );
			 $cached[] = array(
							'url' => $item->get_permalink(),
							'title' => $item->get_title(),
							'date' => $item->get_date( 'd M Y' ),
							'content' => rtrim( $matches[1] ) . '...',
					   );
		}
		$items = $cached;
		set_transient( 'templatic_dashboard_news', $cached, 60 * 60 * 24 );
	}
				?>
	<ul class="news">
		<?php foreach ( $items as $item ) : ?>
	  <li class="post"> <a href="<?php echo $item['url']; ?>" class="rsswidget"><?php echo $item['title']; ?></a> <span class="rss-date"><?php echo $item['date']; ?></span>
		<div class="rssSummary"><?php echo strip_tags( $item['content'] ); ?></div>
	  </li>
		<?php endforeach;?>
	</ul>
  </div>
</div>
<div class="t_theme">
  <div class="t_thumb">
	<?php
		  $lastTheme = get_transient( 'templatic_dashboard_theme' );
				 $lastTheme = file_get_contents( '//templatic.com/latest-theme/' );

	if ( $lastTheme ) { echo $lastTheme;
	} ?>
  </div>
  <hr/>
  <p class="sub"><strong>
	<?php echo __( 'More...','templatic' ); ?>
	</strong></p>
  <ul id="templatic-services">
	<li><a href="//templatic.com/support"><?php echo __( 'Need support?','templatic' );?> </a></li>
	<li><a href="//templatic.com/free-theme-install-service/"><?php echo __( 'Custom services','templatic' );?></a></li>
	<li><a href="//templatic.com/premium-themes-club"><?php echo __( 'Join our theme club','templatic' );?></a></li>
  </ul>
</div>
<div class="clearfix"></div>
<?php
}
add_action( 'admin_menu', 'register_theme_settings_menu',9999 );
/*Function Name: register_theme_settings_menu
Purpose		 : To create submenu for theme settings in Appearance menu
*/
if ( ! function_exists( 'register_theme_settings_menu' ) ) {
	function register_theme_settings_menu() {
		add_submenu_page( 'themes.php', __( 'Custom CSS Editor','templatic' ),__( 'Custom CSS Editor','templatic' ),'manage_options', 'templatic_custom_css_editor', 'templatic_custom_css_editor_settings', '', 100 );
	}
}
/*
Name: templatic_custom_css_editor_settings
desc: save custom css in an option table
*/
function templatic_custom_css_editor_settings() {
	$title = __( 'Custom CSS Editor','templatic' );
	$file = get_template_directory() . '/custom.css';?>
	
	
	<?php
	$theme = 'wppremium2';
	if ( $theme ) {
		$stylesheet = $theme;
	} else { 		$stylesheet = get_stylesheet();
	}

	$theme = wp_get_theme( $stylesheet );
	$allowed_files = $theme->get_files( 'php', 1 );
	$has_templates = ! empty( $allowed_files );
	$style_files = $theme->get_files( 'css' );
	$allowed_files['style.css'] = @$style_files['style.css'];
	$allowed_files += $style_files;

	$relative_file = 'custom.css';
	/* if action set to updates write custom.css file then redirect on currect place */
	if ( isset( $_POST['action'] ) && $_POST['action'] == 'update' ) {

		check_admin_referer( 'edit-theme_' . $file . $stylesheet );
		$newcontent = wp_unslash( $_POST['custom_css_content'] );
		update_option( 'directory_custom_css',$newcontent );
		$location = 'themes.php?page=templatic_custom_css_editor';
		$location .= '&updated=true';
		wp_redirect( $location );
		exit;
	}
	$content = '';
	if ( file_exists( $file ) ) {
		if ( ! @$error && filesize( $file ) > 0 ) {
			$f = fopen( $file, 'r' );
			$content = fread( $f, filesize( $file ) );

			if ( '.php' == substr( $file, strrpos( $file, '.' ) ) ) {
				$functions = wp_doc_link_parse( $content );

				$docs_select = '<select name="docs-list" id="docs-list">';
				$docs_select .= '<option value="">' . esc_attr__( 'Function Name&hellip;' ) . '</option>';
				foreach ( $functions as $function ) {
					$docs_select .= '<option value="' . esc_attr( urlencode( $function ) ) . '">' . htmlspecialchars( $function ) . '()</option>';
				}
				$docs_select .= '</select>';
			}

			$content = esc_textarea( $content );
		}
	}
	?>
	<div class="wrap">
	<h2><?php echo esc_html( $title ); ?></h2>
	 <p> <?php echo sprintf( __( 'You can customize the theme by entering CSS classes in this section. Enter only the classes you want to overwrite (not the whole style.css file). For details on using custom.css open %s.','templatic' ),'<a href="//templatic.com/docs/using-custom-css-for-theme-customizations/">this article</a>' );?></p>
   
	<?php if ( isset( $_GET['updated'] ) && $_GET['updated'] == 'true' ) { ?>
		<div class="updated" id="message"><p><?php echo __( 'File edited successfully.','templatic' ); ?></p></div>
	<?php } ?>
	<form name="custom_css" id="template" action="" method="post">
	<?php wp_nonce_field( 'edit-theme_' . $file . $stylesheet ); ?>
		<div><textarea cols="70" rows="30" name="custom_css_content" id="custom_css_content" aria-describedby="newcontent-description"><?php echo $content; ?></textarea>
		<input type="hidden" name="action" value="update" />
		<input type="hidden" name="file" value="<?php echo esc_attr( $relative_file ); ?>" />
		<input type="hidden" name="theme" value="<?php echo esc_attr( $theme->get_stylesheet() ); ?>" />
		<input type="hidden" name="scrollto" id="scrollto" value="0" />
		<?php
		if ( get_option( 'directory_custom_css' ) ) {
			if ( is_writeable( $file ) ) :
				submit_button( __( 'Update File','templatic' ), 'primary', 'submit', true );
			else : ?>
		<p><em><?php __( 'You need to make this file writable before you can save your changes. See <a href="//codex.wordpress.org/Changing_File_Permissions">the Codex</a> for more information in directory root folder.','templatic' ); ?></em></p>
		<?php endif;
		} else {
			submit_button( __( 'Update File', 'templatic' ), 'primary', 'submit', true );
		}?>
		</div>
	</form>
	</div>
<?php
}
/*
Save the custom.css file
*/
add_action( 'admin_init','save_custom_css' ); /* save from admin */
add_action( 'init','save_custom_css' );  /* save from front end  */
function save_custom_css() {
	$file = get_template_directory() . '/custom.css';
	$theme = 'wppremium2';
	if ( $theme ) {
		$stylesheet = $theme;
	} else { 		$stylesheet = get_stylesheet();
	}

	/* get the teme name and data */
	$theme = wp_get_theme( $stylesheet );
	if ( get_option( 'directory_custom_css' ) ) {
		if ( ! file_exists( $file ) ) {
			fopen( $file, 'w+' );
		}
	}
	$newcontent = get_option( 'directory_custom_css' );
	/* check  the file is writable or not means it should have 755 permition */
	if ( is_writeable( $file ) ) {
		//is_writable() not always reliable, check return value. see comments @ //uk.php.net/is_writable
		$f = fopen( $file, 'w+' );
		if ( $f !== false ) {
			fwrite( $f, $newcontent );
			fclose( $f );
			$theme->cache_delete();
		}
	}
}
/*  add sub menu page for wppremium updates  */
add_action( 'admin_menu','wppremium_theme_menu',11 );
function wppremium_theme_menu() {

	add_menu_page( 'Templatic', 'Templatic', 'administrator', 'templatic_menu', 'tmpl_theme_update', '' );

}

/* Theme update login form*/
function tmpl_theme_update() {

	require_once( get_template_directory() . '/functions/templatic_login.php' );
}
?>
