<?php
/* get the color settings from customizer and write in theme_options.css file located in functions */
function wppremium_hex2rgb( $hex = '' ) {
	$hex = str_replace( '#', '', $hex );

	if ( strlen( $hex ) == 3 ) {
		$r = hexdec( substr( $hex,0,1 ) . substr( $hex,0,1 ) );
		$g = hexdec( substr( $hex,1,1 ) . substr( $hex,1,1 ) );
		$b = hexdec( substr( $hex,2,1 ) . substr( $hex,2,1 ) );
	} else {
		$r = hexdec( substr( $hex,0,2 ) );
		$g = hexdec( substr( $hex,2,2 ) );
		$b = hexdec( substr( $hex,4,2 ) );
	}
	$rgb = array( $r, $g, $b );
	//return implode(",", $rgb); // returns the rgb values separated by commas
	return $rgb; // returns an array with the rgb values
}

/*
    File contain the code for color options in customizer
*/

global $wpdb;
/* get the different colors */
if ( function_exists( 'templatic_theme_settings' ) ) {
	$color1 = templatic_theme_settings( 'color_picker_color1' );
	$color2 = templatic_theme_settings( 'color_picker_color2' );
	$color3 = templatic_theme_settings( 'color_picker_color3' );
	$color4 = templatic_theme_settings( 'color_picker_color4' );
	$color5 = templatic_theme_settings( 'color_picker_color5' );
	$color6 = templatic_theme_settings( 'color_picker_color6' );

} else {
	$templatic_theme_settings = get_option( 'templatic_theme_settings' );
	if ( isset( $templatic_theme_settings['color_picker_color1'] ) && $templatic_theme_settings['color_picker_color1'] != '' ) :
		$color1 = $templatic_theme_settings['color_picker_color1'];
	else :
		$color1 = '';
	endif;

	if ( isset( $templatic_theme_settings['color_picker_color2'] ) && $templatic_theme_settings['color_picker_color2'] != '' ) :
		$color2 = $templatic_theme_settings['color_picker_color2'];
	else :
		$color2 = '';
	endif;

	if ( isset( $templatic_theme_settings['color_picker_color3'] ) && $templatic_theme_settings['color_picker_color3'] != '' ) :
		$color3 = $templatic_theme_settings['color_picker_color3'];
	else :
		$color3 = '';
	endif;

	if ( isset( $templatic_theme_settings['color_picker_color4'] ) && $templatic_theme_settings['color_picker_color4'] != '' ) :
		$color4 = $templatic_theme_settings['color_picker_color4'];
	else :
		$color4 = '';
	endif;

	if ( isset( $templatic_theme_settings['color_picker_color5'] ) && $templatic_theme_settings['color_picker_color5'] != '' ) :
		$color5 = $templatic_theme_settings['color_picker_color5'];
	else :
		$color5 = '';
	endif;

	if ( isset( $templatic_theme_settings['color_picker_color6'] ) && $templatic_theme_settings['color_picker_color6'] != '' ) :
		$color6 = $templatic_theme_settings['color_picker_color6'];
	else :
		$color6 = '';
	endif;
}// End if().

//Change color of body background
if ( $color1 != '#' || $color1 != '' ) {
	$color1_rgba = wppremium_hex2rgb( $color1 );
	$none = '';
	if ( $color1 != '' ) {
		$none = 'none';
	}
	$color_data = <<<COLOR1
	
body {
	background-color: $color1;
}

.top-bar-section li ul.dropdown li a {
	background-color: $color1 !important;
}	

COLOR1;
}// End if().


//Change blue color
if ( $color2 != '#' || $color2 != '' ) {
	$color2_rgba = wppremium_hex2rgb( $color2 );
	$color2_1 = '';
	$color2_2 = 0;
	$color2_3 = 0;
	if ( $color2_rgba[0] >= 0 && $color2_rgba[1] > 0 ) {
		$color2_1 = $color2_rgba[0];
	}
	if ( $color2_rgba[1] > 0 ) {
		$color2_2 = $color2_rgba[1];
	}
	if ( $color2_rgba[2] > 0 ) {
		$color2_3 = $color2_rgba[2];
	}

	if ( $color2 != '' ) {
		$none = 'none';
	}

	$color_data .= <<<COLOR2

.header,
.top-bar-section li.active:not(.has-form) a:not(.button),
input[type="submit"],
ul.pagination li.current a,
ul.pagination li.current a:hover, ul.pagination li.current a:focus,
.top-bar-section li:not(.has-form) a:hover:not(.button),
.top-bar-section li.active:not(.has-form) a:hover:not(.button),
.top-bar-section li.active:not(.has-form) a:not(.button) {
	background-color: $color2;
}

.top-bar-section li ul.dropdown li a:hover {
	background-color: $color2 !important;
}

a,
.breadcrumbs > * {
	color: $color2;
}

COLOR2;
}// End if().



//Change color of page content
if ( $color3 != '#' || $color3 != '' ) {
	$color3_rgba = wppremium_hex2rgb( $color3 );
	$color3_1 = '';
	$color3_2 = 0;
	$color3_3 = 0;
	if ( $color3_rgba[0] >= 0 && $color3_rgba[1] > 0 ) {
		$color3_1 = $color3_rgba[0];
	}
	if ( $color3_rgba[1] > 0 ) {
		$color3_2 = $color3_rgba[1];
	}
	if ( $color3_rgba[2] > 0 ) {
		$color3_3 = $color3_rgba[2];
	}

	$color_data .= <<<COLOR3

.main-view .article-header h1 a,
.content-box .sidebar .widget h3.widget-title,
.widget .widget_tabs .tabs.radius dd > a,
a:hover, a:focus {
	color: $color3;
}

COLOR3;
}// End if().





//Change color of lighter-gray
if ( $color4 != '#' || $color4 != '' ) {
	if ( $color4 != '' ) {
		$none = 'none';
	}
	$color4_rgba = wppremium_hex2rgb( $color4 );
	$color4_1 = '';
	$color4_2 = 0;
	$color4_3 = 0;
	if ( $color4_rgba[0] >= 0 && $color4_rgba[1] > 0 ) {
		$color4_1 = $color4_rgba[0];
	}
	if ( $color4_rgba[1] > 0 ) {
		$color4_2 = $color4_rgba[1];
	}
	if ( $color4_rgba[2] > 0 ) {
		$color4_3 = $color4_rgba[2];
	}
	$color_data .= <<<COLOR4

.header:before {
	background-color: $color4;
}

body,
.byline,
.entry-content dd,
blockquote, blockquote p,
.widget .widget_tabs .tabs-content ul li .byline,
.widget.widget_categories ul li,
.top-bar-section ul li > a,
input[type="text"], input[type="password"], input[type="date"], input[type="datetime"], input[type="datetime-local"], input[type="month"], input[type="week"], input[type="email"], input[type="number"], input[type="search"], input[type="tel"], input[type="time"], input[type="url"], textarea {
	color: $color4;
}

.top-bar-section li ul.dropdown li a {
	color: $color4 !important;
}

.header {
	border-color: $color2;
}

COLOR4;
}// End if().



//Change color of h1,h2...h6 - heading
if ( $color5 != '#' || $color5 != '' ) {
	$color_data .= <<<COLOR5

h1, h2, h3, h4, h5, h6,
.widget .widget_tabs .tabs.radius dd.active a {
	color: $color5; 
}

COLOR5;
}

//Change color of body background
if ( $color6 != '#' || $color6 != '' ) {
	$color1_rgba = wppremium_hex2rgb( $color6 );
	$none = '';
	if ( $color6 != '' ) {
		$none = 'none';
	}
	$color_data .= <<<COLOR6
	
.content-box #main {
	background-color: $color6;
}	

COLOR6;
}
// Finish Color 1 if condition


// Finish If Condition

/* Write/Put the content in css file*/
if ( isset( $_POST['wp_customize'] ) && $_POST['wp_customize'] == 'on' ) {
	if ( is_writable( trailingslashit( get_template_directory() ) . '/functions/theme_options.css' ) ) {
		file_put_contents( trailingslashit( get_template_directory() ) . '/functions/theme_options.css' , $color_data );
	}
}
